Hoofdstuk 4. Opwaarderen vanuit Debian 8 (jessie)

Inhoudsopgave

4.1. Zich op de opwaardering voorbereiden
4.1.1. Maak een reservekopie van alle gegevens en configuratie-informatie
4.1.2. Informeer gebruikers vooraf
4.1.3. Bereid u voor op het feit dat diensten een tijd onbeschikbaar zullen zijn
4.1.4. Tref voorbereidingen om een hersteloperatie te kunnen uitvoeren
4.1.5. Maak een veilige omgeving klaar voor de opwaardering
4.2. De toestand van het systeem controleren
4.2.1. Kijk na of het programma voor pakketbeheer acties in de wachtrij heeft staan
4.2.2. APT-verankering (pinning) uitschakelen
4.2.3. De toestand van pakketten controleren
4.2.4. De archiefafdeling proposed-updates
4.2.5. Niet-officiële pakketbronnen
4.3. Pakketbronnen voor APT klaarmaken
4.3.1. Op het internet aanwezige pakketbronnen voor APT toevoegen
4.3.2. APT-pakketbronnen van een lokale spiegelserver toevoegen
4.3.3. APT-pakketbronnen van optische media toevoegen
4.4. Pakketten opwaarderen
4.4.1. De sessie opnemen
4.4.2. De pakketlijst bijwerken
4.4.3. Zorg voor voldoende vrije schijfruimte voor de opwaardering
4.4.4. Een minimale opwaardering van het systeem
4.4.5. Het systeem opwaarderen
4.5. Mogelijke problemen tijdens de opwaardering
4.5.1. De opdracht dist-upgrade mislukt met de foutmelding Kon de onmiddellijke configuratie niet uitvoeren
4.5.2. Te verwachten verwijderingen
4.5.3. Vicieuze cirkels van conflicten of voorvereisten
4.5.4. Bestandsconflicten
4.5.5. Configuratiewijzigingen
4.5.6. Verspringen van de sessie naar een console
4.6. Uw kernel en aanverwante pakketten opwaarderen
4.6.1. Een kernel-metapakket installeren
4.7. Voorbereid zijn op de volgende release
4.7.1. Verwijderde pakketten wissen
4.8. Verouderde pakketten
4.8.1. Dummypakketten

4.1. Zich op de opwaardering voorbereiden

We raden aan dat u voor de opwaardering ook de informatie leest in Hoofdstuk 5, Kwesties waarvan u zich bewust moet zijn bij stretch. In dat hoofdstuk worden mogelijke problemen behandeld die niet rechtstreeks in verband staan met het opwaarderingsproces zelf, maar waarvan het toch belangrijk is dat u erover geïnformeerd bent voor u met de opwaardering begint.

4.1.1. Maak een reservekopie van alle gegevens en configuratie-informatie

Het wordt sterk aanbevolen om een volledige back-up te maken voor u het systeem opwaardeert, of dat u minstens een reservekopie maakt van alle gegevens en alle configuratie-informatie die u zeker niet mag verliezen. Het opwaarderingsgereedschap en het opwaarderingsproces zijn behoorlijk betrouwbaar, maar een stoornis van de hardware middenin de opwaardering zou kunnen leiden tot een ernstig beschadigd systeem.

De belangrijkste zaken waarvan u een reservekopie zou moeten maken zijn de inhoud van /etc, /var/lib/dpkg en van /var/lib/apt/extended_states en de uitvoer van dpkg --get-selections "*" (de aanhalingstekens hebben hun belang). Indien u aptitude gebruikt om de pakketten op uw systeem te beheren, neemt u best ook een reservekopie van /var/lib/aptitude/pkgstates.

Het opwaarderingsproces zelf verandert niets in de map /home. Maar het is bekend dat sommige toepassingen (bijv. onderdelen van de Mozilla-suite en de desktopomgevingen GNOME en KDE) bestaande gebruikersinstellingen overschrijven met nieuwe standaardwaarden wanneer de gebruiker voor het eerst een nieuwe versie van de toepassing start. Bij wijze van voorzorg kunt u een reservekopie maken van de verborgen bestanden en mappen (dotfiles of puntbestanden) in de persoonlijke mappen van de gebruikers. Een dergelijke back-up kan helpen bij het herstellen of het opnieuw creëren van de vroegere instellingen. Wellicht wilt u uw gebruikers daarover ook inlichten.

Elke pakketinstallatiebewerking moet uitgevoerd worden met de voorrechten van de superuser, dus als systeembeheerder. Daarom moet u zich ofwel aanmelden als gebruiker root of het commando su of sudo gebruiken om de vereiste toegangsrechten te verwerven.

De opwaardering stelt een aantal voorwaarden waaraan vooraf voldaan moet worden. Controleer ze vooraleer u de opwaardering daadwerkelijk uitvoert.

4.1.2. Informeer gebruikers vooraf

Het is verstandig om alle gebruikers vooraf te informeren over elke opwaardering die u van plan bent uit te voeren, hoewel gebruikers die via een ssh-verbinding op uw systeem werken, weinig zouden mogen merken van de opwaardering en gewoon zouden moeten kunnen voortwerken.

Wenst u extra voorzorgsmaatregelen te nemen, maak dan voor de opwaardering een reservekopie van de /home-partitie of koppel ze af.

U zult een opwaardering van de kernel moeten uitvoeren bij het opwaarderen naar stretch. Een herstart van het systeem zal dus nodig zijn. Gewoonlijk wordt dit gedaan na het afronden van de opwaardering.

4.1.3. Bereid u voor op het feit dat diensten een tijd onbeschikbaar zullen zijn

Mogelijk levert uw systeem diensten die gekoppeld zijn aan pakketten die bij de opwaardering betrokken zijn. Is dit het geval, houd er dan rekening mee dat deze diensten tijdens de opwaardering gestopt zullen worden terwijl de betreffende pakketten vervangen en geconfigureerd worden. Gedurende die tijd zullen die diensten niet beschikbaar zijn.

De exacte duur van onbeschikbaarheid van deze diensten kan variëren afhankelijk van het aantal pakketten dat op het systeem opgewaardeerd wordt. Ook de tijd die de systeembeheerder nodig heeft voor het beantwoorden van eventuele configuratievragen die gepaard gaan met de opwaardering van de pakketten, speelt daarin mee. Noteer dat als het opwaarderingsproces zonder toezicht verloopt en het systeem om invoer vraagt tijdens de opwaardering, er een grote kans bestaat dat diensten gedurende een significante periode onbeschikbaar[1] zullen blijven.

Indien het systeem dat opgewaardeerd wordt, cruciale diensten levert voor uw gebruikers of voor het netwerk[2], kunt u de periode van onbeschikbaarheid verkleinen door een minimale opwaardering van het systeem uit te voeren, zoals beschreven wordt in Paragraaf 4.4.4, “Een minimale opwaardering van het systeem”, daarna een opwaardering van de kernel uit te voeren, het systeem vervolgens opnieuw te starten en pas nadien de pakketten die verband houden met die cruciale diensten op te waarderen. Waardeer deze pakketten in een dergelijk geval op vooraleer u een "full upgrade", een volledige opwaardering, uitvoert zoals beschreven in Paragraaf 4.4.5, “Het systeem opwaarderen”. Op die manier kunt u ervoor zorgen dat deze cruciale diensten actief en beschikbaar zijn gedurende het proces van volledige opwaardering, zodat de tijd waarin ze onbeschikbaar zijn beperkt gehouden wordt.

4.1.4. Tref voorbereidingen om een hersteloperatie te kunnen uitvoeren

Hoewel Debian er tracht voor te zorgen dat uw systeem op elk moment tot opstarten in staat blijft, blijft er altijd een kans bestaan dat u na de opwaardering problemen ervaart bij het herstarten van het systeem. Mogelijke problemen die bekend zijn, worden in dit en de volgende hoofdstukken van deze notities bij de release behandeld.

Om die reden heeft het zin dat u voorbereidingen treft om in staat te zijn aan de situatie te verhelpen, mocht blijken dat het heropstarten van het systeem mislukt, of het herstellen van de netwerkfunctionaliteit bij vanop afstand beheerde systemen niet succesvol is.

Indien u de opwaardering via een ssh-verbinding vanop afstand uitvoert, is het aangeraden om de nodige voorzorgen te treffen zodat u in staat bent toegang te hebben tot de server via een externe seriële terminal. De mogelijkheid bestaat dat u na het opwaarderen van de kernel en het herstarten van het systeem, via een lokale console de systeemconfiguratie zult moeten repareren. Ook is het mogelijk dat wanneer het systeem middenin de opwaardering per ongeluk herstart wordt, u via een lokale console herstelwerkzaamheden zult moeten uitvoeren.

Voor noodherstel bevelen we over het algemeen het gebruik aan van de reparatiemodus van de Debian Installer van stretch. Het voordeel van het gebruik van het installatiesysteem is dat u de keuze heeft uit zijn talrijke methodes om er die uit te kiezen die het beste aansluit bij uw situatie. Voor bijkomende informatie kunt u de paragraaf Een defect systeem herstellen uit hoofdstuk 8 van de Installatiehandleiding raadplegen en ook de Debian Installer FAQ.

Indien dat mislukt zult u een andere manier moeten vinden om uw systeem op te starten, zodat u er toegang toe krijgt en het kunt herstellen. Een mogelijkheid is een speciaal reparatie-image gebruiken of een Linux live-CD. Nadat u daarmee het systeem opgestart heeft, zou u in staat moeten zijn het basisbestandssysteem ervan aan te koppelen en die omgeving terug binnen te gaan met het commando chroot om het probleem te onderzoeken en te repareren.

4.1.4.1. Een debug-shell tijdens het opstarten met initrd

Het pakket initramfs-tools voegt een debug-shell[3] toe aan het initrds dat het genereert. Indien bijvoorbeeld het initrd er niet in slaagt om uw basisbestandssysteem aan te koppelen, zult u terechtkomen in die debug-shell waarin basiscommando's ter beschikking staan die u kunnen helpen om het probleem op te sporen en te onderzoeken en het eventueel te repareren.

Basisgegevens die u moet controleren zijn: de aanwezigheid van correcte apparaatbestanden in /dev; welke modules geladen zijn (cat /proc/modules); de uitvoer van dmesg op foutmeldingen over het laden van stuurprogramma's. De uitvoer van dmesg zal ook laten zien welk apparaatbestand toegewezen werd aan welke schijf; u moet dit toetsen aan de uitvoer van echo $ROOT om er zeker van te zijn dat het basisbestandssysteem zich op het verwachte apparaat bevindt.

Indien u er in slaagt het probleem te verhelpen, kunt u de debug-shell verlaten door exit te typen en vervolgens zal het opstartproces op het punt waarop het mislukte verdergaan. Natuurlijk zult u ook het onderliggende probleem moeten repareren en het initrd opnieuw moeten genereren, zodat de volgende herstart niet opnieuw mislukt.

4.1.4.2. Een debug-shell tijdens het opstarten met systemd

Indien onder systemd het opstarten mislukt, kunt u een debug-shell voor root krijgen door de commandoregel voor de kernel aan te passen. Indien basaal opstarten wel lukt, maar sommige diensten niet willen starten, kan het nuttig zijn om systemd.unit=rescue.target toe te voegen aan de parameters voor de kernel.

Anders zal de kernelparameter systemd.unit=emergency.target u zo vroeg mogelijk een root-shell leveren. Dit gebeurt echter voordat het basisbestandssysteem aangekoppeld wordt met lees- en schrijfrechten. U zult dit handmatig moeten doen met:

mount -o remount,rw /

Meer informatie over het onderzoeken en repareren van een defect opstartproces onder systemd is te vinden in het artikel Diagnosing Boot Problems.

4.1.5. Maak een veilige omgeving klaar voor de opwaardering

Het opwaarderen van de distributie moet ofwel lokaal gebeuren in tekstmodus vanaf een virtuele console (of een rechtstreeks aangesloten seriële terminal), ofwel vanop afstand via een ssh-verbinding.

[Belangrijk]Belangrijk

Indien u bepaalde VPN-diensten (zoals tinc) gebruikt, zijn die mogelijk niet beschikbaar gedurende het opwaarderingsproces. Zie in dat verband Paragraaf 4.1.3, “Bereid u voor op het feit dat diensten een tijd onbeschikbaar zullen zijn”.

Om bij het vanop afstand opwaarderen een extra veiligheidsmarge in te bouwen, suggereren we dat u de opwaarderingsprocessen uitvoert in de virtuele console die door het programma screen geleverd wordt. Dit laat toe om op een veilige manier opnieuw verbinding te maken en garandeert dat het opwaarderingsproces niet onderbroken wordt, zelfs als het proces van verbinden vanop afstand, fout loopt.

[Belangrijk]Belangrijk

Voer de opwaardering niet uit met telnet, rlogin, rsh, of vanuit een X-sessie die beheerd wordt door xdm, gdm of kdm, enz. op de computer die u gaat opwaarderen. De reden is dat elk van deze diensten tijdens de opwaardering beëindigd zal worden, hetgeen kan leiden tot een ontoegankelijk systeem dat slechts gedeeltelijk opgewaardeerd is. Het gebruik van de GNOME-toepassing update-manager wordt stellig ontraden voor opwaarderingen naar een nieuwe release, vermits het voor dit programma nodig is dat de desktopsessie actief blijft.

4.2. De toestand van het systeem controleren

Het opwaarderingsproces dat in dit hoofdstuk beschreven wordt, is ontworpen voor opwaarderingen van pure jessie-systemen zonder pakketten van derden. Om uw opwaarderingsproces zo betrouwbaar mogelijk te laten verlopen, zou u ervoor kunnen kiezen om deze pakketten van derden van het systeem te verwijderen voor u met opwaarderen begint.

Hieronder worden twee methodes aangereikt om dergelijke pakketten te vinden. De ene met aptitude en de andere met apt-forktracer. Houd er rekening mee dat geen van beide 100% accuraat werkt (het voorbeeld met aptitude levert bijvoorbeeld ook pakketten op die ooit door Debian geleverd werden maar nu niet meer, zoals oude kernelpakketten).

$ aptitude search '~i(!~ODebian)'
$ apt-forktracer | sort

Rechtstreekse opwaarderingen vanaf uitgaven van Debian die ouder zijn dan 8 (jessie) worden niet ondersteund. Volg de instructies uit de Notities bij de uitgave van Debian 8 om eerst naar 8 op te waarderen.

Deze werkwijze veronderstelt ook dat uw systeem reeds opgewaardeerd is naar de recentste onderversie (point release) van jessie. Is dat nog niet gebeurd of weet u het niet, volg dan de instructies uit Paragraaf A.1, “Uw jessie-systeem opwaarderen”.

4.2.1. Kijk na of het programma voor pakketbeheer acties in de wachtrij heeft staan

In sommige gevallen gebeurt het dat wanneer apt-get in plaats van aptitude gebruikt werd voor het installeren van pakketten, het programma aptitude een pakket als ongebruikt gaat beschouwen en het in de wachtrij plaatst om verwijderd te worden. In het algemeen zou u er moeten voor zorgen dat het systeem volledig up-to-date en zuiver is voor u met het opwaarderen begint.

Om die reden zou u moeten nagaan of er in het programma voor pakketbeheer aptitude geen acties in de wachtrij staan. Indien er in het programma voor pakketbeheer ingepland staat dat een pakket verwijderd of opgewaardeerd moet worden, kan dit de opwaarderingsprocedure negatief beïnvloeden. Merk op dat u dit enkel kunt corrigeren als uw bestand sources.list nog steeds verwijst naar jessie en niet naar stable of stretch; zie Paragraaf A.2, “Het controleren van uw bronnenlijst”.

Om dit te onderzoeken moet u het programma aptitude opstarten in volledige-terminalmodus en op g (Go) drukken. Indien het programma bepaalde acties toont, moet u ze onderzoeken en ze ofwel repareren of de voorgestelde acties uitvoeren. Indien er geen acties gesuggereerd worden, zult u de melding krijgen Er zijn geen pakketten gepland voor installatie, opwaardering of verwijdering.

4.2.2. APT-verankering (pinning) uitschakelen

Indien u APT geconfigureerd heeft om bepaalde pakketten te installeren uit een andere distributie dan uit stable (bijvoorbeeld uit testing), zult u de configuratie voor APT pinning (opgeslagen in /etc/apt/preferences en /etc/apt/preferences.d/) moeten wijzigen om de opwaardering van pakketten naar versies uit de nieuwe stabiele release mogelijk te maken. Bijkomende informatie over APT-verankering (pinning) is te vinden in de man-pagina apt_preferences(5).

4.2.3. De toestand van pakketten controleren

Ongeacht de gebruikte methode van opwaarderen is het aanbevolen om eerst de toestand van alle pakketten te controleren en na te gaan of alle pakketten zich in een opwaardeerbare toestand bevinden. Het volgende commando toont pakketten die een status hebben van Half-Installed (gedeeltelijk geïnstalleerd) of Failed-Config (mislukte configuratie) en de pakketten met een foutstatus.

# dpkg --audit

U kunt de toestand van alle pakketten op uw systeem ook controleren met aptitude of met commando's zoals

# dpkg -l | pager

of

# dpkg --get-selections "*" > ~/curr-pkgs.txt

Het is wenselijk om eventuele 'hold'-markeringen (pakketten die gemarkeerd staan als te handhaven in de huidige versie) voor de opwaardering te verwijderen. Indien een pakket dat essentieel is voor de opwaardering als te handhaven gemarkeerd staat, zal de opwaardering mislukken.

Merk op dat aptitude een andere methode gebruikt dan apt-get en dselect om te registreren dat een pakket op de huidige versie gehandhaafd moet worden. U kunt de pakketten die voor aptitude als te handhaven geboekt staan, vinden met

# aptitude search "~ahold" 

Wilt u nagaan welke pakketten voor apt-get als te handhaven ingesteld staan, dan moet u het volgende commando gebruiken

# dpkg --get-selections | grep 'hold$'

Indien u lokaal een pakket aanpaste en opnieuw compileerde, maar het geen andere naam gaf of geen epoch in het versienummer opnam, dan moet u het markeren als te handhaven (on hold) om te voorkomen dat het opgewaardeerd wordt.

U kunt voor apt-get de 'te handhaven'-status van een pakket wijzigen met:

# echo pakket_naam hold | dpkg --set-selections

Vervang hold door install om de hold-status (de 'te handhaven'-status) ongedaan te maken.

Als er nog iets is dat u moet repareren, is het best om ervoor te zorgen dat uw bestand sources.list nog blijft verwijzen naar jessie, zoals uitgelegd werd in Paragraaf A.2, “Het controleren van uw bronnenlijst”.

4.2.4. De archiefafdeling proposed-updates

Indien u in uw bestand /etc/apt/sources.list de archiefafdeling proposed-updates opgenomen heeft, moet u die vermelding verwijderen uit dat bestand vooraleer u uw systeem probeert op te waarderen. Dit is een voorzorgsmaatregel om de kans op conflicten te verkleinen.

4.2.5. Niet-officiële pakketbronnen

Als u op uw systeem pakketten heeft die niet van Debian afkomstig zijn, moet u weten dat deze tijdens de opwaardering eventueel verwijderd kunnen worden wegens tegenstrijdige vereisten. Indien deze pakketten geïnstalleerd werden via het toevoegen van een extra pakketarchief in uw bestand /etc/apt/sources.list, ga dan na of dat archief ook pakketten aanbiedt die gecompileerd werden voor stretch en pas die pakketbronregel aan op hetzelfde moment waarop u de pakketbronregels voor de pakketten van Debian aanpast.

Het is mogelijk dat sommige gebruikers op hun jessie-systeem recentere versies hebben, afkomstig van niet-officiële backports (voor de stabiele release geschikt gemaakte recentere softwareversies), van pakketten die wel degelijk in Debian aanwezig zijn. Dergelijke pakketten hebben een grote kans om tijdens de opwaardering voor problemen te zorgen, vermits ze kunnen leiden tot bestandsconflicten[4]. Paragraaf 4.5, “Mogelijke problemen tijdens de opwaardering” bevat enig informatie over hoe u met bestandsconflicten kunt omgaan mochten die zich manifesteren.

4.3. Pakketbronnen voor APT klaarmaken

Voor u met opwaarderen begint moet u het configuratiebestand van apt voor pakketlijsten, /etc/apt/sources.list, instellen.

apt houdt rekening met alle pakketten die via een van de deb-regels te vinden zijn en installeert het pakket met het hoogste versienummer. Daarbij geeft het voorrang aan de eerste regel in het bestand (indien u dus gebruik maakt van verschillende spiegelserverlocaties, zult u gewoonlijk eerst een lokale harde schijf vermelden, dan CD's en daarna verder verwijderde spiegelservers).

Dikwijls kan naar een uitgave verwezen worden met zijn codenaam (bijv. jessie, stretch) en met zijn statusnaam (d.w.z. oldstable, stable, testing, unstable). Naar een uitgave verwijzen met de codenaam ervan heeft het voordeel dat u nooit verrast zult worden door een nieuwe uitgave. Om die reden gebruiken we hier deze benadering. Dit betekent natuurlijk dat u zelf zult moeten uitkijken naar de aankondiging van een nieuwe uitgave. Maakt u daarentegen gebruik van de statusnaam, dan zult u van zodra een release plaats vond merken dat er voor een massa pakketten updates beschikbaar gekomen zijn.

Debian gebruikt twee mailinglijsten voor het doen van aankondigingen, zodat u op de hoogte kunt blijven van relevante informatie over de releases van Debian:

4.3.1. Op het internet aanwezige pakketbronnen voor APT toevoegen

De standaardconfiguratie staat zo ingesteld dat voor installaties via het internet gebruik gemaakt wordt van de hoofdservers van Debian. U zult wellicht het bestand /etc/apt/sources.list willen aanpassen om andere spiegelservers te gebruiken, bij voorkeur een spiegelserver die in netwerktermen het meest dichtstbij is.

De adressen van Debian spiegelservers zijn te vinden op https://www.debian.org/distrib/ftplist (kijk bij de paragraaf met als titel Lijst van Debian spiegelservers). Merk op dat de FTP-spiegelservers niet langer in gebruik zijn - zie Paragraaf A.2, “Het controleren van uw bronnenlijst”.

Bijvoorbeeld, veronderstel dat de dichtstbijzijnde Debian spiegelserver http://mirrors.kernel.org is. Als u op deze spiegelserver met een webbrowser gaat kijken, dan zult u merken dat de hoofdmappen op de volgende manier georganiseerd zijn:

http://mirrors.kernel.org/debian/dists/stretch/main/binary-ppc64el/...
http://mirrors.kernel.org/debian/dists/stretch/contrib/binary-ppc64el/...

Om met apt van deze spiegelserver gebruik te maken, voegt u deze regel toe aan het bestand sources.list:

deb http://mirrors.kernel.org/debian stretch main contrib

Merk op dat dists impliciet toegevoegd wordt en dat de argumenten na de naam van de release gebruikt worden om het pad uit te breiden tot meerdere mappen.

Nadat u de nieuwe pakketbronnen toegevoegd heeft in sources.list, moet u de eerdere deb-regels die er in voorkomen deactiveren door er een hash-teken (#) voor te plaatsen.

4.3.2. APT-pakketbronnen van een lokale spiegelserver toevoegen

In plaats van een HTTP-pakketspiegelserver te gebruiken kunt u /etc/apt/sources.list ook instellen om gebruik te maken van een spiegelserver op een lokale harde schijf (mogelijk aangekoppeld over NFS).

Bijvoorbeeld, uw pakketspiegelserver bevindt zich onder /var/local/debian/ en heeft de volgende hoofdmappen:

/var/local/debian/dists/stretch/main/binary-ppc64el/...
/var/local/debian/dists/stretch/contrib/binary-ppc64el/...

Om met apt van deze spiegelserver gebruik te maken, voegt u deze regel toe aan het bestand sources.list:

deb file:/var/local/debian stretch main contrib

Merk op dat dists impliciet toegevoegd wordt en dat de argumenten na de naam van de release gebruikt worden om het pad uit te breiden tot meerdere mappen.

Nadat u de nieuwe pakketbronnen toegevoegd heeft in sources.list, moet u de eerdere deb-regels die er in voorkomen deactiveren door er een hash-teken (#) voor te plaatsen.

4.3.3. APT-pakketbronnen van optische media toevoegen

Indien u enkel CD's (of DVD's of blu-ray-dvd's) wenst te gebruiken, maak dan van de bestaande deb-regels in /etc/apt/sources.list eenvoudige commentaarregels door er een hash-teken (#) voor te plaatsen.

Controleer of /etc/fstab een regel bevat die het mogelijk maakt om uw CD-station aan te koppelen aan het aankoppelpunt /media/cdrom. Indien bijvoorbeeld /dev/sr0 uw CD-station is, moet /etc/fstab een regel bevatten zoals deze:

/dev/sr0 /media/cdrom auto noauto,ro 0 0

Merk op dat er geen spaties mogen staan tussen de woorden noauto,ro in het vierde veld.

Om na te gaan of het werkt, kunt u een CD in het station plaatsen en de volgende commando's uitvoeren:

# mount /media/cdrom    # hiermee koppelt u de CD aan het aankoppelpunt aan
# ls -alF /media/cdrom  # dit moet de inhoud tonen van de basismap van de CD
# umount /media/cdrom   # hiermee ontkoppelt u de CD opnieuw

Voer vervolgens het volgende commando uit:

# apt-cdrom add

voor elke CD met Debian-pakketten waarover u beschikt, om zo de gegevens over elke CD toe te voegen aan de databank van APT.

4.4. Pakketten opwaarderen

De aanbevolen manier om op te waarderen vanuit eerdere releases van Debian is het pakketbeheergereedschap apt-get gebruiken. Bij eerdere releases werd voor dit doel aptitude aanbevolen, maar de nieuwste versies van apt-get bieden een evenwaardige functionaliteit en hebben ook bewezen op een meer consistente wijze de gewenste opwaarderingsresultaten te kunnen leveren.

Vergeet niet alle partities die nodig zijn (in het bijzonder de root-partitie en de /usr-partitie), aan te koppelen voor lezen en schrijven met een commando zoals:

# mount -o remount,rw /aankoppelpunt

Nadien moet u zeker nog eens controleren of de vermeldingen van de pakketbronnen voor APT (in /etc/apt/sources.list) ofwel verwijzen naar stretch of naar stable. Er zouden geen pakketbronvermeldingen mogen verwijzen naar jessie.

[Opmerking]Opmerking

Regels waarin een CD als pakketbron functioneert verwijzen soms naar unstable. Hoewel dit voor verwarring zorgt, mag u deze regel niet aanpassen.

4.4.1. De sessie opnemen

Het wordt sterk aanbevolen dat u het programma /usr/bin/script gebruikt om een transcriptie te maken van de opwaarderingssessie. Als er zich dan een probleem voordoet, zult u een logbestand hebben met een beschrijving van wat er gebeurde en kunt u zo nodig exacte informatie geven in een bugrapport. Om het opnemen te starten, typt u:

# script -t 2>~/upgrade-stretchstap.time -a ~/upgrade-stretchstap.script

of iets dergelijks. Indien u het script opnieuw moet starten (bijv. als u het systeem moet herstarten), gebruik dan andere waarden voor stap om een aanduiding te hebben over voor welke stap in het opwaarderingsproces u een logbestand aanmaakt. Laat het script zijn logbestand niet in een tijdelijke map, zoals /tmp of /var/tmp plaatsen (bestanden in deze mappen kunnen verwijderd worden tijdens de opwaardering of bij een herstart van de computer).

De transcriptie zal u ook de mogelijkheid bieden om informatie na te kijken die tijdens de opwaardering over het scherm wegscrolde. Als u zich aan de console van het systeem bevindt, moet u gewoon overschakelen naar VT2 (met Alt+F2) en nadat u aangemeld bent, het commando less -R ~root/upgrade-stretch.script gebruiken om het bestand in te kijken.

Nadat u de opwaardering afgerond heeft, kunt u het programma script stoppen door aan de prompt exit te typen.

Indien u het programma script met de schakeloptie -t gebruikte, kunt u het programma scriptreplay gebruiken om de hele sessie opnieuw af te spelen:

# scriptreplay ~/upgrade-stretch.time ~/upgrade-stretch.script

4.4.2. De pakketlijst bijwerken

Eerst moet de lijst met beschikbare pakketten uit de nieuwe uitgave opgehaald worden. Dit gebeurt met het volgende commando:

# apt-get update

4.4.3. Zorg voor voldoende vrije schijfruimte voor de opwaardering

Vooraleer u uw systeem opwaardeert moet u ervoor zorgen dat u voldoende vrije schijfruimte zult hebben als u begint aan de fase van volledige opwaardering van het systeem die beschreven wordt in Paragraaf 4.4.5, “Het systeem opwaarderen”. Eerst worden alle pakketten die geïnstalleerd moeten worden en die over het netwerk opgehaald moeten worden, opgeslagen in /var/cache/apt/archives (en, tijdens het downloaden, in de onderliggende map partial/). Daarom moet u de zekerheid hebben dat u op de bestandssysteempartitie waarop /var/ zich bevindt, voldoende ruimte beschikbaar heeft om tijdelijk de pakketten die op uw systeem geïnstalleerd zullen worden, ernaartoe te downloaden. Nadat het downloaden afgelopen is, zult u vermoedelijk ook op andere bestandssysteempartities extra ruimte nodig hebben, niet enkel om de pakketten die opgewaardeerd worden te installeren (waarvan de uitvoerbare bestanden of de bestanden met data mogelijk groter zijn), maar ook voor het installeren van nieuwe pakketten die ten gevolge van de opwaardering noodzakelijk geworden zijn. Als uw systeem niet voldoende schijfruimte beschikbaar heeft, kunt u eindigen met een niet volledig opgewaardeerd systeem dat nog moeilijk te repareren valt.

apt-get kan u gedetailleerde informatie geven over de schijfruimte die voor de installatie vereist is. Voor u met de opwaardering start, kunt u daarvan een schatting krijgen met het commando:

# apt-get -o APT::Get::Trivial-Only=true dist-upgrade
[ ... ]
XXX opgewaardeerd, XXX nieuwe installaties , XXX te verwijderen en XXX niet opgewaardeerd.
Moet xx.xMB archieven ophalen. 
Na deze operatie zal AAAMB bijkomende schijfruimte gebruikt worden.
[Opmerking]Opmerking

Als u dit commando uitvoert bij de aanvang van het opwaarderingsproces, kunt u een foutmelding krijgen omwille van de redenen die in de paragrafen hierna beschreven worden. In een dergelijk geval zult u moeten wachten tot na de minimale opwaardering van het systeem, zoals beschreven in Paragraaf 4.4.4, “Een minimale opwaardering van het systeem”, om dit commando uit te voeren en het de vereiste schijfruimte te laten schatten.

Indien u onvoldoende vrije ruimte voor de opwaardering heeft, zal apt-get u met een melding zoals deze waarschuwen:

E: U heeft onvoldoende vrije ruimte in /var/cache/apt/archives/.

Als die situatie zich voordoet, moet u vooraf voldoende vrije ruimte maken. U kunt:

  • Pakketten verwijderen die vroeger werden gedownload om geïnstalleerd te worden (in /var/cache/apt/archives). Als u de pakketcache opruimt met het commando apt-get clean, zullen alle eerder gedownloade pakketbestanden verwijderd worden.

  • Vergeten pakketten verwijderen. Indien u aptitude of apt-get gebruikte om in jessie handmatig pakketten te installeren, zullen die gereedschappen bijgehouden hebben dat u die pakketten handmatig installeerde. Deze programma's voor pakketbeheer zijn in staat om pakketten, die enkel geïnstalleerd werden omdat ze door andere pakketten vereist werden, als overbodig te markeren, wanneer de pakketten die aan hen behoefte hadden, zelf verwijderd werden. Maar pakketten die u handmatig installeerde, zullen deze nooit als overbodig markeren. Om automatisch geïnstalleerde pakketten die niet langer gebruikt worden te verwijderen, geeft u het commando:

    # apt-get autoremove
    

    U kunt ook deborphan, debfoster of cruft gebruiken om overbodige pakketten op te sporen. Verwijder niet blindweg alle pakketten die door deze programma's voorgesteld worden, zeker als u ze gebruikt met opties die niet standaard en agressief zijn en die de kans op valse positieven vergroten. Het wordt sterk aangeraden om handmatig de pakketten te onderzoeken (d.w.z. hun inhoud, grootte en beschrijving) waarvan deze programma's de verwijdering voorstellen vooraleer ze daadwerkelijk te verwijderen.

  • Verwijder pakketten die teveel ruimte in beslag nemen en die momenteel niet nodig zijn (u kunt ze altijd opnieuw installeren na de opwaardering). Indien u popularity-contest installeerde, kunt u het commando popcon-largest-unused gebruiken voor een lijst van niet gebruikte pakketten die de meeste ruimte in beslag nemen. Om gewoon te weten welke pakketten de meeste schijfruimte in beslag nemen kunt u het commando dpigs (uit het pakket debian-goodies) gebruiken of wajig (met het commando wajig size). Ook met aptitude kunt u ze vinden. Start aptitude in volledige-terminalmodus, selecteer WeergavenNieuwe Vlakke Pakketlijst, druk op l en voer ~i in, druk daarna op S en voer ~installsize in. Dit zal u een lijst geven waarmee u op een handige manier kunt werken.

  • Verwijder vertalingen en taaldefinitiebestanden van het systeem als ze niet nodig zijn. U kunt het pakket localepurge installeren en het zo configureren dat enkel een paar geselecteerde taaldefinities behouden worden op het systeem. Hierdoor zult u de schijfruimte die door /usr/share/locale gebruikt wordt, beperken.

  • Verplaats de systeemlogboekbestanden onder /var/log/ tijdelijk naar een ander systeem of verwijder ze definitief.

  • Gebruik een tijdelijke /var/cache/apt/archives: u kunt een tijdelijke cachemap gebruiken op een ander bestandssysteem (USB-opslagapparaat, een tijdelijke harde schijf, een bestandssysteem dat al in gebruik is, ...)

    [Opmerking]Opmerking

    Gebruik geen bestandssysteem dat via NFS aangekoppeld is, aangezien de netwerkverbinding tijdens de opwaardering onderbroken kan worden.

    Indien u bijvoorbeeld een USB-schijf aangekoppeld heeft op /media/usbkey:

    1. verwijder de pakketten die eerder gedownload werden met het oog op installatie:

      # apt-get clean

    2. kopieer de map /var/cache/apt/archives naar de USB-schijf:

      # cp -ax /var/cache/apt/archives /media/usbkey/

    3. koppel de tijdelijke cachemap aan op de huidige:

      # mount --bind /media/usbkey/archives /var/cache/apt/archives

    4. hetstel na de opwaardering de originele /var/cache/apt/archives-map:

      # umount /media/usbkey/archives

    5. verwijder de achtergebleven /media/usbkey/archives.

    U kunt de tijdelijke cachemap aanmaken op om het even welk bestandssysteem dat aan uw systeem aangekoppeld is.

  • Voer een minimale opwaardering van het systeem uit (zie Paragraaf 4.4.4, “Een minimale opwaardering van het systeem”) of partiële opwaarderingen gevolgd door een volledige opwaardering. Dit maakt het mogelijk om het systeem gedeeltelijk op te waarderen en de pakketcache leeg te maken vooraleer de volledige opwaardering uit te voeren.

Merk op dat om het verwijderen van pakketten veilig te laten verlopen het aangeraden is om uw sources.list-bestand terug in te stellen voor jessie, zoals beschreven wordt in Paragraaf A.2, “Het controleren van uw bronnenlijst”.

4.4.4. Een minimale opwaardering van het systeem

In sommige gevallen kan het onmiddellijk uitvoeren van een volledige opwaardering (zoals die hieronder beschreven wordt) leiden tot het verwijderen van een groot aantal pakketten die u wenst te behouden. Daarom bevelen we u een opwaardering in twee fases aan: eerst een minimale upgrade uitvoeren om de conflicten uit te schakelen die aanleiding geven tot dat fenomeen en daarna een volledige opwaardering uitvoeren, zoals beschreven in Paragraaf 4.4.5, “Het systeem opwaarderen”.

Om dit te bereiken geeft u eerst het commando

# apt-get upgrade
[Opmerking]Opmerking

Bij sommige eerdere uitgaven werd het gebruik van aptitude aanbevolen voor het uitvoeren van de opwaardering. Voor de opwaardering van jessie naar stretch bevelen we dat gereedschap niet aan.

Dit heeft de opwaardering tot gevolg van die pakketten die opgewaardeerd kunnen worden zonder dat andere pakketten verwijderd of geïnstalleerd moeten worden.

Een minimale opwaardering van het systeem kan ook nuttig zijn als het systeem slechts over beperkte opslagruimte beschikt en een volledige opwaardering omwille van opslagruimtebeperkingen niet toegepast kan worden.

Indien het pakket apt-listchanges geïnstalleerd is, zal het (bij zijn standaardconfiguratie) paginagewijs belangrijke informatie over opgewaardeerde pakketten laten zien. Druk na het lezen van de informatie op q om de paginagewijze weergave te verlaten en voort te gaan met de opwaardering.

4.4.5. Het systeem opwaarderen

Nadat u de voorgaande stappen gezet heeft, bent u nu klaar om voort te gaan met het belangrijkste onderdeel van de opwaardering. Voer het volgende commando uit:

# apt-get dist-upgrade
[Opmerking]Opmerking

Bij sommige eerdere uitgaven werd het gebruik van aptitude aanbevolen voor het uitvoeren van de opwaardering. Voor de opwaardering van jessie naar stretch bevelen we dat gereedschap niet aan.

Dit zal een volledige opwaardering van het systeem uitvoeren, de meest recente beschikbare versies van alle pakketten installeren, een oplossing bieden voor alle mogelijke gewijzigde vereisten (meestal nieuwe bibliotheekversies of hernoemde pakketten) die pakketten hebben vergeleken bij de vorige uitgave, en alle in de weg zittende verouderde pakketten verwijderen.

Indien u de opwaardering uitvoert met een set CD's/DVD's/BD's, zult u wellicht op verschillende momenten tijdens de opwaardering gevraagd worden een specifieke schijf in het station te plaatsen. Het is mogelijk dat u verschillende malen dezelfde schijf in het station moet plaatsen. Dit heeft te maken met pakketten die met elkaar verband houden en verspreid over de verschillende schijven opgeslagen werden.

Momenteel geïnstalleerde pakketten die niet opgewaardeerd kunnen worden naar een recentere versie zonder de installatiestatus van een ander geïnstalleerd pakket te wijzigen, zullen op hun huidige versie behouden blijven (dit wordt als gehandhaafd weergegeven). Dit kan opgelost worden door ofwel aptitude te gebruiken om deze pakketten te selecteren als te installeren pakketten of door het commando apt-get install pakket te gebruiken.

4.5. Mogelijke problemen tijdens de opwaardering

In de volgende paragrafen worden bekende problemen beschreven die zich eventueel kunnen manifesteren bij een opwaardering naar stretch.

4.5.1. De opdracht dist-upgrade mislukt met de foutmelding Kon de onmiddellijke configuratie niet uitvoeren

In sommige gevallen kan de stap apt-get dist-upgrade na het downloaden van de pakketten mislukken met:

E: Kon de onmiddellijke configuratie voor 'pakket' niet uitvoeren.  Raadpleeg man 5 apt.conf onder APT::Immediate-Configure voor  bijzonderheden.

Als dit zich voordoet, zou het mogelijk moeten zijn om de opwaardering voort te zetten door apt-get dist-upgrade -o APT::Immediate-Configure=0 als commando te gebruiken.

Een andere mogelijke oplossing voor dit probleem is om tijdelijk zowel de pakketbronnen voor jessie als voor stretch op te nemen in uw sources.list-bestand en het commando apt-get update te geven.

4.5.2. Te verwachten verwijderingen

Het proces van opwaarderen naar stretch kan om het verwijderen van pakketten vragen. De exacte lijst van pakketten kan verschillen afhankelijk van welke pakketten op uw systeem geïnstalleerd zijn. In deze notities bij de release worden algemene adviezen in verband met deze verwijderingen gegeven, maar bij twijfel is het aangeraden om bij elke gebruikte opwaarderingsmethode de voorgestelde pakketverwijderingen te onderzoeken vooraleer verder te gaan. Meer informatie over in stretch verouderde pakketten vindt u in Paragraaf 4.8, “Verouderde pakketten”.

4.5.3. Vicieuze cirkels van conflicten of voorvereisten

Soms is het noodzakelijk om in APT de optie APT::Force-LoopBreak te activeren om in staat te zijn om tijdelijk een essentieel pakket te verwijderen omwille van een vicieuze cirkel van het type 'Conflicts/Pre-Depends' ('Is tegenstrijdig met/Heeft als voorvereiste'). apt-get zal u over een dergelijk probleem waarschuwen en de opwaardering afbreken. U kunt dit probleem omzeilen door aan de commandoregel van apt-get de optie -o APT::Force-LoopBreak=1 op te geven.

Het is mogelijk dat de vereistenstructuur van een systeem dermate defect is dat een manuele interventie noodzakelijk is. Gewoonlijk betekent dit dat apt-get gebruikt zal moeten worden of

# dpkg --remove pakket_naam

om sommige van de voor problemen zorgende pakketten uit de weg ruimen, of

# apt-get -f install
# dpkg --configure --pending

In extreme gevallen kan het gebeuren dat u her-installatie moet forceren met een commando zoals

# dpkg --install /pad/naar/pakket_naam.deb

4.5.4. Bestandsconflicten

Bestandsconflicten zouden zich niet mogen voordoen als u een zuiver jessie-systeem opwaardeert, maar ze kunnen wel optreden als u niet-officiële backports (een na een release verschenen recentere pakketversie die voor die release geschikt gemaakt werd) geïnstalleerd heeft. Bij een bestandsconflict krijgt u een foutmelding zoals:

Uitpakken van <pakket-foo> (uit <pakket-foo-bestand>) ...
dpkg: fout bij het verwerken van <pakket-foo> (--install):
 poging tot overschrijven van `<een-bestands-naam>',
 ook aanwezig in pakket <pakket-bar>
dpkg-deb: subproces plakken gedood door signaal (Defecte pijp)
 Er deden zich fouten voor bij het verwerken van:
 <pakket-foo>

U kunt een bestandsconflict proberen op te lossen door het pakket dat op de laatste regel van de foutmelding vermeld wordt, geforceerd te verwijderen:

# dpkg -r --force-depends pakket_naam

Nadat u dit gerepareerd heeft, zou u in staat moeten zijn om de opwaardering te hervatten door de eerder beschreven apt-get-commando's nogmaals uit te voeren.

4.5.5. Configuratiewijzigingen

Tijdens de opwaardering zult u vragen krijgen in verband met de configuratie of de herconfiguratie van verschillende pakketten. Wanneer u gevraagd wordt of een bestand in de map /etc/init.d of het bestand /etc/manpath.config moet vervangen worden door de versie van de pakketonderhouder, is het meestal nodig om te antwoorden met yes om de consistentie van het systeem te verzekeren. U kunt steeds terugkeren naar de oudere versie, vermits die bewaard zal worden met de extensie .dpkg-old.

Indien u twijfelt wat u moet doen, kunt u de naam van het pakket of het bestand noteren en de zaak uitzoeken op een later moment. U kunt in het transcriptiebestand de informatie die tijdens de opwaardering op het scherm verscheen, nog eens nalezen.

4.5.6. Verspringen van de sessie naar een console

Indien u de lokale console van het systeem gebruikt om de opwaardering uit te voeren, kunt u ondervinden dat u op sommige momenten tijdens de opwaardering plots een ander scherm te zien krijgt en het zicht op het verloop van het opwaarderingsproces verloren bent. Dit kan bijvoorbeeld gebeuren op desktopsystemen wanneer de beeldschermbeheerder opnieuw opgestart wordt.

Om de console te herstellen waarop de opwaardering liep, zult u de toetsencombinatie Ctrl+Alt+F1 (als u zich in het grafische opstartscherm bevindt) of Alt+F1 (als u zich in de lokale tekstmodus-console bevindt) moeten gebruiken om terug te keren naar de virtuele terminal 1. Vervang F1 door de functietoets die hetzelfde cijfer heeft als het cijfer van de virtuele terminal waarin de opwaardering uitgevoerd werd. U kunt ook Alt+Pijl Links of Alt+Pijl Rechts gebruiken om te wisselen tussen de verschillende tekstmodus-terminals.

4.6. Uw kernel en aanverwante pakketten opwaarderen

In deze paragraaf wordt uitgelegd hoe u uw kernel opwaardeert en worden mogelijke problemen behandeld die met deze opwaardering verband houden. U kunt ofwel een van de door Debian aangeboden linux-image-*-pakketten installeren of een aangepaste kernel compileren uit de broncode.

Merk op dat veel van de informatie uit deze paragraaf uitgaat van de aanname dat u een van de modulaire kernels van Debian gebruikt samen metinitramfs-tools en udev. Indien u ervoor kiest om een aangepaste kernel te gebruiken die geen initrd nodig heeft of indien u een andere initrd-generator gebruikt, zal bepaalde informatie voor u mogelijk niet relevant zijn.

4.6.1. Een kernel-metapakket installeren

Wanneer u met het commando dist-upgrade de stap zet van volledige opwaardering van jessie naar stretch, wordt het sterk aanbevolen een linux-image-*-metapakket te installeren als u dit voordien nog niet deed. Deze metapakketten installeren tijdens upgrades automatisch recentere versies van de kernel. U kunt nagaan of u een metapakket geïnstalleerd heeft met het commando

# dpkg -l "linux-image*" | grep ^ii | grep -i meta

Indien u geen uitvoer te zien krijgt, zult u ofwel zelf handmatig het pakket met een recentere kernelversie moeten installeren ofwel een linux-image-metapakket. Om de lijst met beschikbare linux-image-metapakketten te krijgen, geeft u de opdracht

# apt-cache search linux-image- | grep -i meta | grep -v transition

Indien u twijfelt over welk pakket u moet selecteren, moet u de opdracht uname -r gebruiken en zoeken naar een pakket met een vergelijkbare naam. Indien u bijvoorbeeld 2.6.32-5-amd64 te zien krijgt, is het aangeraden om linux-image-amd64 te installeren. U kunt ook gebruik maken van apt-cache om een uitgebreide beschrijving van elk pakket te zien, hetgeen u kan helpen bij het kiezen van het beste pakket uit de beschikbare pakketten. Bijvoorbeeld:

# apt-cache show linux-image-amd64

U moet dan apt-get install gebruiken om het te installeren. Nadat deze nieuwe kernel geïnstalleerd is, moet u bij de eerst mogelijke gelegenheid het systeem herstarten om te kunnen genieten van de voordelen die de nieuwe kernelversie biedt. Lees echter zeker eerst Paragraaf 5.1.4, “Zaken die na de opwaardering en voor het herstarten van de computer moeten gebeuren” voor u na de opwaardering de computer voor het eerst herstart.

Voor de meer avontuurlijk aangelegde personen staat er in Debian een gemakkelijke methode ter beschikking om een eigen aangepaste kernel te compileren. Installeer de broncode van de kernel die in het pakket linux-source te vinden is. U kunt het deb-pkg-target uit de makefile van de broncode gebruiken om een binair pakket te bouwen. Meer informatie is te vinden in het Debian Linux Kernel Handbook, dat ook beschikbaar is onder de vorm van het pakket debian-kernel-handbook.

Als dit mogelijk is, heeft u er voordeel bij om het kernelpakket afzonderlijk en los van de algemene dist-upgrade op te waarderen om de kansen te verkleinen dat het systeem zich tijdelijk in een niet-opstartbare toestand bevindt. Merk op dat u dit pas mag doen na het minimale opwaarderingsproces, beschreven in Paragraaf 4.4.4, “Een minimale opwaardering van het systeem”.

4.7. Voorbereid zijn op de volgende release

Na de opwaardering kunt u verschillende zaken doen om voorbereid te zijn op de volgende release.

4.7.1. Verwijderde pakketten wissen

Over het algemeen is het aanbevolen om verwijderde pakketten te wissen (met het commando purge van APT). Dit is in het bijzonder het geval als ze bij een eerdere release-upgrade verwijderd werden (bijvoorbeeld bij de opwaardering naar jessie) of als ze door een derde geleverd waren. In het bijzonder van init.d-scripts is bekend dat deze voor problemen kunnen zorgen.

[Let op]Let op

Door een pakket te wissen worden over het algemeen ook de logboekbestanden ervan gewist. Misschien wilt u er eerst een reservekopie van maken.

Het volgende commando toont een lijst van alle verwijderde pakketten waarvan er mogelijk configuratiebestanden achtergebleven zijn op het systeem (indien van toepassing):

# dpkg -l | awk '/^rc/ { print $2 }'

De pakketten kunnen gewist worden met het commando apt-get purge. In de veronderstelling dat u ze allemaal tegelijk wilt wissen, kunt u het volgende commando gebruiken:

# apt-get purge $(dpkg -l | awk '/^rc/ { print $2 }')

Indien u aptitude gebruikt, kunt u als alternatief voor de bovenstaande commando's ook het volgende gebruiken:

$ aptitude search '~c'
$ aptitude purge '~c'

4.8. Verouderde pakketten

Worden er met stretch veel nieuwe pakketten geïntroduceerd, dan worden er ook heel wat oude pakketten die in jessie zaten met pensioen gestuurd of weggelaten. Voor deze verouderde pakketten is geen opwaardering meer voorzien. Hoewel niets u belet om desgewenst een verouderd pakket te blijven gebruiken, zal het Debian-project gewoonlijk een jaar na de uitgave van stretch[5] de beveiligingsondersteuning ervan stopzetten en in die tussentijd gewoonlijk ook geen andere ondersteuning meer bieden. Als er alternatieven voor de verouderde pakketten beschikbaar zijn, is het aangeraden om ze door een dergelijk alternatief te vervangen.

Er kunnen veel redenen zijn waarom een pakket verwijderd werd uit de distributie: zij worden door de toeleveraar niet langer onderhouden; er is niet langer een ontwikkelaar van Debian geïnteresseerd in het onderhoud van het pakket; de geboden functionaliteit werd door andere software (of door een nieuwere versie) overgenomen; of omdat ze bugs bevatten worden zij niet langer als geschikt beschouwd voor stretch. In dit laatste geval kan het pakket wel nog aanwezig zijn in de distributie unstable.

Vaststellen welke pakketten in een opgewaardeerd systeem verouderd zijn, is eenvoudig, vermits de front-ends voor pakketbeheer ze ook als zodanig zullen markeren. Indien u aptitude gebruikt, zult u een lijst van deze pakketten vinden onder het item Verouderde en lokaal aangemaakte pakketten.

Het Bugopvolgingssysteem van Debian verschaft dikwijls bijkomende informatie over de redenen voor het verwijderen van een pakket. U moet zowel de bugrapporten voor het pakket zelf als de bugrapporten voor het pseudo-pakket ftp.debian.org erop nakijken.

Raadpleeg voor een lijst van voor Stretch verouderde pakketten Paragraaf 5.1.3, “Vermeldenswaardige uitgefaseerde pakketten”

4.8.1. Dummypakketten

Sommige pakketten uit jessie werden in stretch opgesplitst in verschillende pakketten, dikwijls om het onderhoud van het systeem te vergemakkelijken. Om in dergelijke gevallen het opwaarderen te vergemakkelijken, stelt stretch vaak dummypakketten ter beschikking: lege pakketten die dezelfde naam hebben als het oude pakket in jessie met vereisten die ervoor zorgen dat de nieuwe pakketten geïnstalleerd worden. Deze dummypakketten worden als overbodig beschouwd na de opwaardering en kunnen probleemloos verwijderd worden.

De beschrijving van de meeste (maar niet alle) dummypakketten vermeldt het doel dat ze hebben. De pakketbeschrijvingen van dummypakketten zijn echter niet uniform, dus wellicht vindt u ook deborphan met een van de opties van het type --guess-* (bijv. --guess-dummy) nuttig om ze op uw systeem te vinden. Merk op dat het bij sommige dummypakketten niet de bedoeling is dat ze na een opwaardering verwijderd worden, omdat ze gebruikt worden om doorheen de tijd zicht te blijven houden op de momenteel beschikbare versie van een programma.



[1] Indien de debconf-prioriteit ingesteld staat op een erg hoog niveau, onderdrukt u mogelijk configuratievragen. Echter, diensten die terugvallen op standaardantwoorden die op uw systeem niet toepasbaar zijn, zullen dan niet kunnen starten.

[2] Voorbeelden zijn DNS- en DHCP-diensten, in het bijzonder wanneer er geen redundantie of automatische doorschakeling voorzien is. In het geval van DHCP kunnen gebruikers afgekoppeld worden van het netwerk als de leasetermijn korter is dan de tijd die nodig is om het opwaarderingsproces te voltooien.

[3] Deze functionaliteit kan uitgezet worden door de parameter panic=0 toe te voegen aan de opstartparameters.

[4] Het pakketbeheersysteem van Debian laat normaal niet toe dat een pakket een bestand verwijdert of vervangt dat eigendom is van een ander pakket, tenzij het bedoeld is om dat pakket te vervangen.

[5] Of voor zover er binnen die tijdspanne geen andere release heeft plaatsgevonden. Normaal worden niet meer dan twee stabiele releases tegelijk ondersteund.